Index: /trunk/doc/manual/fr_FR/user_AdvancedTopics.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_AdvancedTopics.xml	(revision 46094)
+++ /trunk/doc/manual/fr_FR/user_AdvancedTopics.xml	(revision 46095)
@@ -262,4 +262,8 @@
       cet environnement. Virtuellement, toutes les distributions Linux/Unix modernes
       s'appuient sur PAM.</para>
+
+      <para>Pour des identifications automatiques sur des distributions Ubuntu
+      (ou dérivées d'Ubuntu), qui utilisent le gestionnaire d'affichage
+      LightDM, merci de voir <xref linkend="autologon_unix_lightdm" />.</para>
 
       <para>Pour des identifications automatiques sur des distributions Ubuntu
Index: /trunk/doc/manual/fr_FR/user_Frontends.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_Frontends.xml	(revision 46094)
+++ /trunk/doc/manual/fr_FR/user_Frontends.xml	(revision 46095)
@@ -41,4 +41,35 @@
     plus loin en détails), le support VRDP sera automatiquement activé puisque
     VBoxHeadless n'a aucun autre moyen de sortie.</para>
+
+    <para>Par défaut, le serveur VRDP utilise  le port TCP
+    <computeroutput>3389</computeroutput>. Vous devrez modifier le port par
+    défaut si vous exécutez plus d'un serveur VRDP, vu que le port ne peut être
+    utilisé que par un serveur à la fois. Il se pourrait aussi que vous deviez
+    le modifier sur les hôtes Windows car le port par défaut pourrait être
+    déjà utilisé par le serveur RDP
+    intégré à Windows lui-même. Les ports 5000 à 5050 sont le plus souvent
+    inusités et pourraient être un bon choix.</para>
+
+    <para>Vous pouvez modifier le port soit dans les paramètres "Affichage" d5
+    l'interface graphique, soit via l'option <computeroutput>--vrdeport</computeroutput>
+    de la commande <computeroutput>VBoxManage modifyvm</computeroutput>. Vous
+    pouvez indiquer une liste séparée par des virgules de ports ou de plages de
+    ports. Utilisez un tiret entre deux numéros de ports pour indiquer une plage.
+    Le serveur VRDP s'appuiera sur <emphasis role="bold">un</emphasis> des
+    ports disponibles au sein de la liste spécifiée. Par exemple, <computeroutput>VBoxManage modifyvm "nom
+    VM" --vrdeport 5000,5010-5012</computeroutput> configurera le
+    serveur pour s'appuyer sur un des ports parmi le 5000, 5010, 5011 ou 5012.
+    Voir <xref
+    linkend="vboxmanage-modifyvm-vrde" /> pour des détails.</para>
+
+    <para>Vous pouvez savoir le port utilisé au final par une VM en fonction
+    avec la commande <computeroutput>VBoxManage showvminfo</computeroutput>,
+    vous pouvez aussi le voir dans l'interface graphique sous l'onglet "En cours
+    d'exécution" de la "Boîte de dialogue d'informations sur la session", accessible
+    depuis le menu "Machine" de la fenêtre de la VM.</para>
+
+    <para>Le support d'IPv6 a été implémenté dans VirtualBox 4.3. Si l'OS hôte
+    supporte l'IPv6, le serveur VRDP écoutera automatiquement les connexions IPv6
+    en plus de celles IPv4.</para>
 
     <para>Par défaut, le serveur VRDP utilise  le port TCP
Index: /trunk/doc/manual/fr_FR/user_GuestAdditions.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_GuestAdditions.xml	(revision 46094)
+++ /trunk/doc/manual/fr_FR/user_GuestAdditions.xml	(revision 46095)
@@ -505,4 +505,16 @@
         <para>Ceci installe automatiquement les bons fichiers et les bons pilotes
         pour la plateforme correspondante (32 ou 64 bits).</para>
+
+        <note><para>Par défaut, sur une installation sans efforts sur un invité
+        Windows 7 ou 8, un pilote graphique XPDM va s'installer. Ce pilote
+        graphique ne supporte pas Windows Aero / Direct3D de l'invité - il faut
+        donc installer à la place le pilote graphique expérimental WDDM. Pour
+        sélectionner ce pilote par défaut, ajoutez le paramètre 
+        <computeroutput>/with_wddm</computeroutput> de la ligne de commande quand
+        vous appelez l'installeur des suppléments invité Windows.</para></note>
+
+        <note><para>Pour que Windows Aero fonctionne correctement sur un invité,
+        la taille de la mémoire graphique de l'invité doit être configurée pour
+        être d'au moins 128 Mo.</para></note>
 
         <para>Pour plus d'options concernant les installations d'invité sans efforts,
Index: /trunk/doc/manual/fr_FR/user_ThirdParty.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_ThirdParty.xml	(revision 46094)
+++ /trunk/doc/manual/fr_FR/user_ThirdParty.xml	(revision 46095)
@@ -263,4 +263,83 @@
         <para>VirtualBox contient des morceaux du noyau NetBSD soumis à la licence
         dans <xref linkend="licNetBsd" />.</para>
+      </listitem>
+
+      <listitem>
+        <para>VirtualBox contient des morceaux de liblightdm-gobject soumis à la
+        licence dans <xref linkend="licLGPL" xrefstyle="template: %n" /> et</para>
+
+        <para>Copyright (C) 2010-2013 Canonical Ltd.; Copyright (C) 2010-2011 Robert Ancell.</para>
+      </listitem>
+
+      <listitem>
+        <para>VirtualBox contient des morceaux de glib soumis à la
+          licence dans <xref linkend="licLGPL" xrefstyle="template: %n" /> et</para>
+
+        <para>Copyright (C) 1995-2011 L'équipe de Glib</para>
+      </listitem>
+
+      <listitem>
+        <para>VirtualBox contient des morceaux de PCRE soumis à la
+          licence dans <xref linkend="licPcre" xrefstyle="template :%n" /> et</para>
+        <para>Copyright (c) 1997-2012 University of Cambridge;
+          Copyright(c) 2009-2012 Zoltan Herczeg;
+          Copyright (c) 2007-2012, Google Inc.
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>VirtualBox contient des morceaux de libffi soumis à la
+          licence dans <xref linkend="licLibffi" xrefstyle="template :%n" /> et</para>
+        <para>
+          Copyright (c) 1996-2012  Anthony Green, Red Hat, Inc et autres.
+          Voir les fichiers du source pour les détails.
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>VirtualBox contient des morceaux de FLTK soumis aux
+          licences dans <xref linkend="licFltk" xrefstyle="template :%n" /> ainsi que
+          dans <xref linkend="licLGPL" xrefstyle="template :%n"/> et  </para>
+        <para>
+          Copyright (C) 1991-2012  L'équipe FLTK
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>VirtualBox contient des morceaux d'Expat soumis à la
+          licence dans <xref linkend="licExpat" xrefstyle="template :%n" /> et</para>
+        <para>
+          Copyright (c) 1998, 1999, 2000 Thai Open Source Software Center Ltd
+          et Clark Cooper; Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006 
+          Responsables d'Expat.
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>VirtualBox contient des morceaux de Fontconfig soumis à la
+          licence dans <xref linkend="licFontconfig" xrefstyle="template :%n" />
+          et</para>
+        <para>
+          Copyright (C) 2001, 2003 Keith Packard
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>VirtualBox contient des morceaux de Freetype soumis à la
+          licence dans <xref linkend="licFreetype" xrefstyle="template :%n" />
+          et</para>
+        <para>
+          Copyright 2012 Le projet FreeType (www.freetype.org). Tous droits
+          réservés.
+        </para>
+      </listitem>
+
+      <listitem>
+        <para>VirtualBox peut contenir du code du SDK  WebM VP8 Codec soumis à la
+        licence dans <xref linkend="licVPX" xrefstyle="template :%n" />
+          et </para>
+        <para>
+          Copyright (c) 2010, The WebM Project authors. Tous droits réservés.
+        </para>
       </listitem>
 
Index: /trunk/doc/manual/fr_FR/user_VBoxManage.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_VBoxManage.xml	(revision 46094)
+++ /trunk/doc/manual/fr_FR/user_VBoxManage.xml	(revision 46095)
@@ -558,14 +558,20 @@
 
           <listitem>
+            <para><computeroutput>--pae on|off</computeroutput>&#xA0;: Ceci active/désactive
+            la PAE (voir <xref
+            linkend="settings-processor" />).</para>
+          </listitem>
+
+          <listitem>
+            <para><computeroutput>--longmode on|off</computeroutput> : Ceci
+            active/désactive le mode long (voir <xref
+            linkend="settings-processor" />).</para>
+          </listitem>
+
+          <listitem>
             <para><computeroutput>--synthcpu on|off</computeroutput>&#xA0;: Ce
             paramètre détermine si VirtualBox présente ou non un processeur
             synthétique à l'invité pour permettre une migration en direct entre
             les systèmes hôtes qui diffèrent de manière significative.</para>
-          </listitem>
-
-          <listitem>
-            <para><computeroutput>--pae on|off</computeroutput>&#xA0;: Ceci active/désactive
-            la PAE (voir <xref
-            linkend="settings-processor" />).</para>
           </listitem>
 
@@ -724,5 +730,5 @@
           <listitem>
             <para><computeroutput>--defaultfrontend
-            default|&lt;nom&gt;</computeroutput>&#xA0;: Ceci vous permet de
+            default|&lt;nom&gt;</computeroutput>&nbsp;: Ceci vous permet de
             spécifier l'interface par défaut qui sera utilisée au démarrage de
             cette VM&#xA0; voir 