Index: /trunk/doc/manual/fr_FR/user_AdvancedTopics.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_AdvancedTopics.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_AdvancedTopics.xml	(revision 46232)
@@ -129,6 +129,6 @@
   </sect1>
 
-  <sect1>
-    <title id="autologon">Identifications automatiques dans l'invité</title>
+  <sect1 id="autologon">
+    <title>Identifications automatiques dans l'invité</title>
 
     <para>VirtualBox fournit des modules invité supplémentaires pour Windows, Linux
@@ -1178,6 +1178,6 @@
     </sect2>
 
-    <sect2>
-      <title id="iscsi-intnet">Accès à des cibles iSCSI via le réseau interne</title>
+    <sect2 id="iscsi-intnet">
+      <title>Accès à des cibles iSCSI via le réseau interne</title>
 
       <para>En fonctionnalité expérimentale, VirtualBox permet d'accéder à une
Index: /trunk/doc/manual/fr_FR/user_BasicConcepts.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_BasicConcepts.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_BasicConcepts.xml	(revision 46232)
@@ -20,6 +20,6 @@
   Internet au système hôte.</para>
 
-  <sect1>
-    <title id="guestossupport">Systèmes d'exploitation invités supportés</title>
+  <sect1 id="guestossupport">
+    <title>Systèmes d'exploitation invités supportés</title>
 
     <para>Comme VirtualBox est conçu pour offrir un environnement de virtualisation
Index: /trunk/doc/manual/fr_FR/user_Frontends.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_Frontends.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_Frontends.xml	(revision 46232)
@@ -5,6 +5,6 @@
   <title>Machines virtuelles distantes</title>
 
-  <sect1>
-    <title id="vrde">Affichage distant (VRDP support)</title>
+  <sect1 id="vrde">
+    <title>Affichage distant (VRDP support)</title>
 
     <para>VirtualBox peut afficher les machines virtuelles à distance, ce qui
Index: /trunk/doc/manual/fr_FR/user_GuestAdditions.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_GuestAdditions.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_GuestAdditions.xml	(revision 46232)
@@ -2,6 +2,6 @@
 <!DOCTYPE chapter PUBLIC "-//OASIS//DTD DocBook XML V4.4//EN"
 "http://www.oasis-open.org/docbook/xml/4.4/docbookx.dtd">
-<chapter>
-  <title id="guestadditions">Les suppléments invité</title>
+<chapter id="guestadditions">
+  <title>Les suppléments invité</title>
 
   <para>Le chapitre précédent traitait de la manière de commencer avec VirtualBox
Index: /trunk/doc/manual/fr_FR/user_Installation.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_Installation.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_Installation.xml	(revision 46232)
@@ -230,6 +230,6 @@
   </sect1>
 
-  <sect1>
-    <title id="install-linux-host">Installing sur des hôtes Linux</title>
+  <sect1 id="install-linux-host">
+    <title>Installing sur des hôtes Linux</title>
 
     <sect2>
@@ -628,6 +628,6 @@
       </sect3>
 
-      <sect3>
-        <title id="linux_install_opts">Options d'installation automatique</title>
+      <sect3 id="linux_install_opts">
+        <title>Options d'installation automatique</title>
 
         <para>Pour configurer le processus d'installation de nos paquets .deb et
@@ -696,6 +696,6 @@
   </sect1>
 
-  <sect1>
-    <title id="install-solaris-host">Installation sur les hôtes Solaris</title>
+  <sect1 id="install-solaris-host">
+    <title>Installation sur les hôtes Solaris</title>
 
     <para>Pour les versions spécifiques de Solaris que nous supportons comme
@@ -705,5 +705,5 @@
     <para>Si vous avez déjà une instance installée de VirtualBox sur votre hôte
     Solaris, merci de la désinstaller avant d'installer une nouvelle instance.
-    Reportez-vous à <xref linkend="uninstallsolhost" /> pour les
+    Reportez-vous à <xref linkend="uninstall-solaris-host" /> pour les
     instructions de désinstallation.</para>
 
@@ -733,6 +733,5 @@
         <computeroutput>pkgadd -G</computeroutput>. Pour plus d'informations,
         reportez-vous au manuel de <computeroutput>pkgadd</computeroutput>&#xA0;;
-        voir aussi <xref
-        linkend="solariszones" />.</para>
+        voir aussi <xref linkend="solaris-zones" />.</para>
       </note>
 
@@ -793,6 +792,6 @@
     </sect2>
 
-    <sect2>
-      <title id="uninstallsolhost">Désinstallation</title>
+    <sect2 id="uninstall-solaris-host">
+      <title>Désinstallation</title>
 
       <para>La désinstallation de VirtualBox sur Solaris qécessite les droits
@@ -829,6 +828,6 @@
     </sect2>
 
-    <sect2>
-      <title id="solariszones">Configurer un espace pour exécuter VirtualBox</title>
+    <sect2 id="solaris-zones">
+      <title>Configurer un espace pour exécuter VirtualBox</title>
 
       <para>À partir de VirtualBox 1.6, il est possible d'exécuter VirtualBox
Index: /trunk/doc/manual/fr_FR/user_Introduction.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_Introduction.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_Introduction.xml	(revision 46232)
@@ -2,6 +2,6 @@
 <!DOCTYPE chapter PUBLIC "-//OASIS//DTD DocBook XML V4.4//EN"
 "http://www.oasis-open.org/docbook/xml/4.4/docbookx.dtd">
-<chapter>
-  <title id="Introduction">Premiers pas</title>
+<chapter id="Introduction">
+  <title>Premiers pas</title>
 
   <para>Bienvenue à $VBOX_PRODUCT!</para>
@@ -114,6 +114,6 @@
   </sect1>
 
-  <sect1>
-    <title id="virtintro">Un peu de terminologie</title>
+  <sect1 id="virtintro">
+    <title>Un peu de terminologie</title>
 
     <para>Quand on parle de virtualisation (mais aussi pour comprendre les
@@ -418,6 +418,6 @@
   </sect1>
 
-  <sect1>
-    <title id="hostossupport">Systèmes d'exploitation hôtes supportés</title>
+  <sect1 id="hostossupport">
+    <title>Systèmes d'exploitation hôtes supportés</title>
 
     <para>Actuellement, VirtualBox fonctionne sur les systèmes d'exploitation 
@@ -960,6 +960,6 @@
     </sect2>
 
-    <sect2>
-      <title id="keyb_mouse_normal">Capturer et rendre le clavier et la souris</title>
+    <sect2 id="keyb_mouse_normal">
+      <title>Capturer et rendre le clavier et la souris</title>
 
       <para>À partir de la version 3.2, VirtualBox offre aux nouvelles machines
@@ -1054,6 +1054,6 @@
     </sect2>
 
-    <sect2>
-      <title id="specialcharacters">Taper des caractères spéciaux</title>
+    <sect2 id="specialcharacters">
+      <title>Taper des caractères spéciaux</title>
 
       <para>Les systèmes d'exploitation prévoient certaines combinaisons de touches
@@ -1552,6 +1552,6 @@
   </sect1>
 
-  <sect1>
-    <title id="configbasics">Configuration d'une machine virtuelle</title>
+  <sect1 id="configbasics">
+    <title>Configuration d'une machine virtuelle</title>
 
     <para>Quand vous sélectionnez une machine virtuelle dans la liste dans la
Index: /trunk/doc/manual/fr_FR/user_Networking.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_Networking.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_Networking.xml	(revision 46232)
@@ -410,6 +410,6 @@
   </sect1>
 
-  <sect1>
-    <title id="network_bridged">Réseau Bridged</title>
+  <sect1 id="network_bridged">
+    <title>Réseau Bridged</title>
 
     <para>Avec le réseau bridgé, VirtualBox utilise un pilote de périphérique 
Index: /trunk/doc/manual/fr_FR/user_Storage.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_Storage.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_Storage.xml	(revision 46232)
@@ -934,6 +934,6 @@
   </sect1>
 
-  <sect1>
-    <title id="storage-iscsi">Serveurs iSCSI</title>
+  <sect1 id="storage-iscsi">
+    <title>Serveurs iSCSI</title>
 
     <para>iSCSI signifie "Internet SCSI" et c'est un standard qui permet d'utiliser
Index: /trunk/doc/manual/fr_FR/user_Troubleshooting.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_Troubleshooting.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_Troubleshooting.xml	(revision 46232)
@@ -164,6 +164,6 @@
     </sect2>
 
-    <sect2>
-      <title id="ts_debugger">Le débogueur de VM intégré</title>
+    <sect2 id="ts_debugger">
+      <title>Le débogueur de VM intégré</title>
 
       <para>VirtualBox inclut un débogueur de VM intégré, qui peut servir aux
Index: /trunk/doc/manual/fr_FR/user_VBoxManage.xml
===================================================================
--- /trunk/doc/manual/fr_FR/user_VBoxManage.xml	(revision 46231)
+++ /trunk/doc/manual/fr_FR/user_VBoxManage.xml	(revision 46232)
@@ -419,6 +419,6 @@
   </sect1>
 
-  <sect1>
-    <title id="vboxmanage-createvm">VBoxManage createvm</title>
+  <sect1 id="vboxmanage-createvm">
+    <title>VBoxManage createvm</title>
 
     <para>Cette commande crée un nouveau fichier de définition de machine virtuelle 
@@ -1685,6 +1685,6 @@
   </sect1>
 
-  <sect1>
-    <title id="vboxmanage-storageattach">VBoxManage storageattach</title>
+  <sect1 id="vboxmanage-storageattach">
+    <title>VBoxManage storageattach</title>
 
     <para>Cette commande attache/modifie/supprime un média de stockage connecté
@@ -3413,6 +3413,6 @@
   </sect1>
 
-  <sect1>
-    <title id="metrics">VBoxManage metrics</title>
+  <sect1 id="metrics">
+    <title>VBoxManage metrics</title>
 
     <para>Cette commande supporte la surveillance de l'utilisation des ressources